-- this frame is the actual icon attached to ItemRefTooltip
local f = CreateFrame("Frame",nil,ItemRefTooltip)
f:SetSize(36,36)
f:SetPoint("TOPRIGHT",ItemRefTooltip,"TOPLEFT",1,-4)
f.texture = f:CreateTexture(nil,"BACKGROUND")
f.texture:SetAllPoints(f)

-- this child frame is an OnUpdate to attempt uncached icons every .2 seconds
f.updater = CreateFrame("Frame",nil,f)
f.updater:Hide()
f.updater:SetScript("OnUpdate",function(self,elapsed)
	self.timer = self.timer + elapsed
	if self.timer > 0.2 then
		self:Hide()
		f.SetIcon(self.iconType,self.iconID)
	end
end)
f.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark")

function f.SetIcon(iconType,iconID)
	local texture
	if iconType=="item" then
		texture = select(10,GetItemInfo(iconID)) or ""
	elseif iconType=="spell" then
		texture = GetSpellTexture(iconID) or ""
	elseif iconType=="achievement" then
		texture = select(10,GetAchievementInfo(iconID)) or ""
	end
	if texture then -- if this is an item, spell or achievement
		if strlen(texture)>0 then -- and texture is an actual path
			f.texture:SetTexture(texture) -- set texture
		else
			f.updater.iconType = iconType -- otherwise note type and id
			f.updater.iconID = iconID
			f.texture:SetTexture(nil) -- clear its texture for now
			f.updater.timer = 0
			f.updater:Show() -- and check again in 0.2 seconds
		end
		f:Show()
	else
		f:Hide()
	end
end

hooksecurefunc("SetItemRef",function(link)
	local iconType,iconID = link:match("\124?H?(%w+):(%d+)")
	f.updater:Hide() -- just in case ItemRefTooltip was closed while waiting for an icon to cache
	f.SetIcon(iconType,iconID)
end)

